Bug 430997 - tx checksum offload settings reported incorrectly
tx checksum offload settings reported incorrectly
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
4.6
All Linux
medium Severity medium
: rc
: ---
Assigned To: Andy Gospodarek
Martin Jenner
:
Depends On:
Blocks: 461304
  Show dependency treegraph
 
Reported: 2008-01-30 18:53 EST by Matt Carlson
Modified: 2014-06-29 18:59 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-05-18 15:27:10 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Matt Carlson 2008-01-30 18:53:42 EST
Description of problem:

The TX checksum offload setting for tg3 devices 5755 and 5787 is reported
incorrectly.


Version-Release number of selected component (if applicable):


How reproducible:

Always.


Steps to Reproduce:
1. Set tx checksum offload by issuing 'ethtool -K ethx tx on'
2. Observe that the tx checksum offload will always be off by issuing
   'ethtool -k ethx'.
3.
  
Actual results:


Expected results:


Additional info:

The bug is in <linux>/net/core/ethtool.c:ethtool_op_get_tx_csum().

< return (dev->features & NETIF_F_IP_CSUM) != 0;
---
> return (dev->features & (NETIF_F_IP_CSUM | NETIF_F_HW_CSUM)) != 0;
Comment 1 Andy Gospodarek 2008-05-08 14:42:49 EDT
Thanks, Matt.  Looks like we need this patch:

commit 8648b3053bff39a7ee4c711d74268079c928a657
Author: Herbert Xu <herbert@gondor.apana.org.au>
Date:   Sat Jun 17 22:06:05 2006 -0700

    [NET]: Add NETIF_F_GEN_CSUM and NETIF_F_ALL_CSUM

    The current stack treats NETIF_F_HW_CSUM and NETIF_F_NO_CSUM
    identically so we test for them in quite a few places.  For the sake
    of brevity, I'm adding the macro NETIF_F_GEN_CSUM for these two.  We
    also test the disjunct of NETIF_F_IP_CSUM and the other two in various
    places, for that purpose I've added NETIF_F_ALL_CSUM.

    Signed-off-by: Herbert Xu <herbert@gondor.apana.org.au>
    Signed-off-by: David S. Miller <davem@davemloft.net>
Comment 2 Andy Gospodarek 2008-05-12 13:02:27 EDT
Actually, the patch in comment #1 is really too much (and not the one that added
the fix).  It sounds like just the original fix will resolve this.
Comment 3 Andy Gospodarek 2008-05-12 14:03:44 EDT
We seem to have most of this patch:

http://www.linux.sgi.com/archives/netdev/2005-05/msg00900.html

but not the part you are requesting (the rest got added during a tg3 update). 
I'll get that added.
Comment 4 RHEL Product and Program Management 2008-05-12 14:21:18 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 5 Andy Gospodarek 2008-05-16 23:03:34 EDT
My test kernels have been updated to include a patch for this bugzilla.

http://people.redhat.com/agospoda/#rhel4

Please test them and report back your results.
Comment 7 RHEL Product and Program Management 2008-09-03 09:14:35 EDT
Updating PM score.
Comment 9 Vivek Goyal 2009-01-08 09:19:03 EST
Committed in 78.25.EL . RPMS are available at http://people.redhat.com/vgoyal/rhel4/
Comment 11 Chris Ward 2009-03-27 10:18:53 EDT
~~ Attention Partners! Snap 1 Released ~~
RHEL 4.8 Snapshot 1 has been released on partners.redhat.com. There should
be a fix present, which addresses this bug. NOTE: there is only a short time
left to test, please test and report back results on this bug
at your earliest convenience.

If you encounter any issues, please set the bug back to the ASSIGNED state and
describe the issues you encountered. If you have found a NEW bug, clone this
bug and describe the issues you encountered. Further questions can be
directed to your Red Hat Partner Manager.

If you have VERIFIED the bug fix. Please select your PartnerID from the
Verified field above. Please leave a comment with your test results details.
Include which arches tested, package version and any applicable logs.

 - Red Hat QE Partner Management
Comment 12 Jeff Leu 2009-03-30 05:23:06 EDT
I have verified this issue on kernel 2.6.9-85.EL.gtest.61.
The tx checksum offload function work.
Comment 14 errata-xmlrpc 2009-05-18 15:27:10 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on therefore solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2009-1024.html

Note You need to log in before you can comment on or make changes to this bug.